<?php

class ControllerExtensionPaymentMabna extends Controller {

	private $error = array();

	public function index() {

		$this->load->language('extension/payment/mabna');
		$this->document->setTitle($this->language->get('doc_title'));
		$this->load->model('setting/setting');
		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) 
		{
			$this->model_setting_setting->editSetting('payment_mabna', $this->request->post);
			$this->session->data['success'] = $this->language->get('text_success');
			$this->response->redirect($this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true));

		}
		$data['heading_title'] = $this->language->get('heading_title');
		$data['text_edit'] = $this->language->get('text_edit');
		$data['text_enabled'] = $this->language->get('text_enabled');
		$data['text_disabled'] = $this->language->get('text_disabled');
		$data['entry_pin'] = $this->language->get('entry_pin');
		$data['entry_order_status'] = $this->language->get('entry_order_status');
		$data['entry_status'] = $this->language->get('entry_status');
		$data['entry_sort_order'] = $this->language->get('entry_sort_order');
		$data['button_save'] = $this->language->get('button_save');
		$data['button_cancel'] = $this->language->get('button_cancel');
		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}
		if (isset($this->error['pin'])) 
		{

			$data['error_pin'] = $this->error['pin'];
		} else 
		{
			$data['error_pin'] = '';
		}
		if (isset($this->error['sh1'])) 
		{
			$data['error_sh1'] = $this->error['sh1'];
		} else 
		{
			$data['error_sh1'] = '';
		}
		
		$data['breadcrumbs'] = array();
		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_payment'),
			'href' => $this->url->link('extension/extension', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('extension/payment/mabna', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['action'] = $this->url->link('extension/payment/mabna', 'user_token=' . $this->session->data['user_token'], true);
		$data['cancel'] = $this->url->link('extension/payment', 'user_token=' . $this->session->data['user_token'], true);
		if (isset($this->request->post['payment_mabna_PIN'])) {
			$data['payment_mabna_PIN'] = $this->request->post['payment_mabna_PIN'];
		} else {
			$data['payment_mabna_PIN'] = $this->config->get('payment_mabna_PIN');
		}
		
		if (isset($this->request->post['payment_mabna_terminal'])) {
			$data['payment_mabna_terminal'] = $this->request->post['payment_mabna_terminal'];
		} else {
			$data['payment_mabna_terminal'] = $this->config->get('payment_mabna_terminal');
		}

		if (isset($this->request->post['payment_mabna_order_status_id'])) {
			$data['payment_mabna_order_status_id'] = $this->request->post['payment_mabna_order_status_id'];
		} else {
			$data['payment_mabna_order_status_id'] = $this->config->get('payment_mabna_order_status_id');
		}
		
		$this->load->model('localisation/order_status');
		$data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();

		if (isset($this->request->post['payment_mabna_status'])) {
			$data['payment_mabna_status'] = $this->request->post['payment_mabna_status'];
		} else {
			$data['payment_mabna_status'] = $this->config->get('payment_mabna_status');
		}
		if (isset($this->request->post['payment_mabna_sort_order'])) {
			$data['payment_mabna_sort_order'] = $this->request->post['payment_mabna_sort_order'];
		} else {
			$data['payment_mabna_sort_order'] = $this->config->get('payment_mabna_sort_order');
		}
		
		if (isset($this->request->post['payment_mabna_title'])) 
		{

			$data['payment_mabna_title'] = $this->request->post['payment_mabna_title'];

		} else {

			$data['payment_mabna_title'] = $this->config->get('payment_mabna_title');

		}

		$data['action'] = $this->url->link('extension/payment/mabna', 'user_token=' . $this->session->data['user_token'], true);
		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('extension/payment/mabna', $data));
	}

	protected function validate() {
		if (!$this->user->hasPermission('modify', 'extension/payment/mabna')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}
		if (!$this->request->post['payment_mabna_PIN']) {
			$this->error['pin'] = $this->language->get('error_pin');
		}
		if (!$this->request->post['payment_mabna_terminal']) {
			$this->error['sh1'] = 'insert terminal';

		}
		return !$this->error;

	}

}

?>