<?php
class ControllerExtensionPaymentmabna extends Controller {
	public function index() {
		$this->language->load('extension/payment/mabna');
    	$data['button_confirm'] = $this->language->get('button_confirm');

		$data['text_loading'] = $this->language->get('text_loading');
		$this->load->model('checkout/order');
		$order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);
		
		$data['order_id'] = $this->session->data['order_id'];
		$data['back'] = $this->url->link('checkout/payment', '', true);
		$amount = $this->currency->format($order_info['total'], $order_info['currency_code'], $order_info['currency_value'], false);
		$amount = round($amount);
		$amount = $this->currency->convert($amount, $order_info['currency_code'], "RLS");
			
        $data['order_id'] = $this->session->data['order_id'];
		$data['redirect_url']  =  ($this->url->link('extension/payment/mabna/callback','', true));
		$data['action'] = "https://mabna.shaparak.ir";
		$pat = dirname(__FILE__);
		if(!function_exists('timestamp_to_iso8601'))
		{
			$get = 'nusoap2.php';
			$pat .= '/';
			for($i = 0; $i < 10; $i++)
			{
				if(!file_exists($pat.$get))
				{
					$pat.="../";
				}else
				{
					break;
				}
			}
			include_once $pat . 'nusoap2.php';
		}
		$amount = trim($amount);
		$invoiceNumber = time();
		$merchant = trim($this->config->get('payment_mabna_PIN'));
		$redirectAddress =$data['redirect_url'];
		$terminal = trim($this->config->get('payment_mabna_terminal'));
		
		 $source = $amount . $invoiceNumber . $merchant . $redirectAddress . $terminal;
		 
		$get = 'public.txt';
		$pat .= '/';
		for($i = 0; $i < 10; $i++)
		{
			if(!file_exists($pat.$get))
			{
				$pat.="../";
			}else
			{
				break;
			}
		}
		$pat .= 'public.txt';
		
		$fp = fopen($pat , "r");
		$pub_key = fread($fp, 8192);
		fclose($fp);
		if (strpos($pub_key, '-----BEGIN PUBLIC KEY-----') === false)
			$pub_key = "-----BEGIN PUBLIC KEY-----\n" . $pub_key;

		if (strpos($pub_key, '-----END PUBLIC KEY-----') === false)
			$pub_key .= "\n-----END PUBLIC KEY-----";


		// Amount
		$key_resource = openssl_get_publickey($pub_key);

		openssl_public_encrypt($amount, $crypttext, $key_resource);

		$Amount = base64_encode($crypttext);
		// CRN

		openssl_public_encrypt($invoiceNumber, $crypttext, $key_resource);
		$CRN = base64_encode($crypttext);

		// MID
		openssl_public_encrypt($merchant, $crypttext, $key_resource);
		$MID = base64_encode($crypttext);

		// TID
		openssl_public_encrypt($terminal, $crypttext, $key_resource);
		$TID = base64_encode($crypttext);

		// redirectAddress
		openssl_public_encrypt($redirectAddress, $crypttext, $key_resource);
		$referal = base64_encode($crypttext);

		$get = 'private.txt';
		$pat = dirname(__FILE__). '/';
		for($i = 0; $i < 10; $i++)
		{
			if(!file_exists($pat.$get))
			{
				$pat.="../";
			}else
			{
				break;
			}
		}
		$pat .= 'private.txt';
		
		$key = file_get_contents($pat);

		if (strpos($key, '-----BEGIN PRIVATE KEY-----') === false)
			$key = "-----BEGIN PRIVATE KEY-----\n" . $key;

		if (strpos($key, '-----END PRIVATE KEY-----') === false)
			$key .= "\n-----END PRIVATE KEY-----";

		$priv_key = openssl_pkey_get_private($key);
		$signature = '';
		openssl_sign($source, $signature, $priv_key, OPENSSL_ALGO_SHA1);
		$inputArray = array("Token_param" => array("AMOUNT" => $Amount,
			"CRN" => $CRN,
			"MID" => $MID,
			"REFERALADRESS" => $referal,
			"SIGNATURE" => base64_encode($signature),
			"TID" => $TID,
		));

		$__SOAP = "https://mabna.shaparak.ir/TokenService?wsdl";
		$client = new nusoap_client($__SOAP, 'wsdl');
		$WSResult = $client->call("reservation", $inputArray);
		
		$signature = base64_decode($WSResult['return']['signature']);

		$ok = openssl_verify($WSResult['return']['token'], $signature, $key_resource);

		openssl_free_key($key_resource);

		if ($ok != 1 || $WSResult['return']['result'] != 0) 
		{
			echo '<br/>خطا در ساخت توکن :<br/>'.$WSResult['return']['token'];
			echo '<br/>کد خطا : <br/>'.$WSResult['return']['result'];
			
		}
		$data['token']=$WSResult['return']['token'];
	
	return $this->load->view('extension/payment/mabna', $data);

		
	}

	public function callback() 
	{
		$this->language->load('payment/mabna');
		@session_start();

		$order_id = isset($this->session->data['order_id']) ? $this->session->data['order_id'] : 0;

		$this->document->setTitle($this->language->get('text_heading'));
		$data['text_wait'] = $this->language->get('text_wait');
		$data['text_heading'] = $this->language->get('text_heading');
		$data['text_results'] = $this->language->get('text_results');
		$data['button_confirm'] = $this->language->get('button_confirm');
		$data['button_continue'] = $this->language->get('button_continue');
		$data['breadcrumbs'] = array();
		$data['breadcrumbs'][] = array('text' => $this->language->get('text_home'), 'href' => $this->url->link('common/home', '', 'SSL'), 'separator' => false);
		$data['breadcrumbs'][] = array('text' => $this->language->get('text_heading'), 'href' => $this->url->link('payment/mabna/callback', '', 'SSL'), 'separator' => $this->language->get('text_separator'));
		$data['error_warning'] = '';

		if( isset($_POST['CRN']) && isset($_POST['TRN']) && isset($_POST['RESCODE']) && $_POST['RESCODE'] == '00' )
		{

			$merchant = trim($this->config->get('payment_mabna_PIN'));
			
			$this->load->model('checkout/order');
			$order_info = $this->model_checkout_order->getOrder($order_id);
			
			$amount = $this->currency->format($order_info['total'], $order_info['currency_code'], $order_info['currency_value'], false);
			$amount = round($amount);
			$amount = $this->currency->convert($amount, $order_info['currency_code'], "RLS");
	
			if ($order_info) 
			{
				$pat = dirname(__FILE__);
				if(!function_exists('timestamp_to_iso8601'))
				{
					$get = 'nusoap2.php';
					$pat .= '/';
					for($i = 0; $i < 10; $i++)
					{
						if(!file_exists($pat.$get))
						{
							$pat.="../";
						}else
						{
							break;
						}
					}
					include_once $pat . 'nusoap2.php';
				}
				
				$client = new nusoap_client("https://mabna.shaparak.ir/TransactionReference/TransactionReference?wsdl", 'wsdl');
				$error = $client->getError();
				
				$get = 'public.txt';
				$pat .= '/';
				for($i = 0; $i < 10; $i++)
				{
					if(!file_exists($pat.$get))
					{
						$pat.="../";
					}else
					{
						break;
					}
				}
				$pat .= 'public.txt';
				
				$fp = fopen($pat , "r");
				$pub_key = fread($fp, 8192);
				fclose($fp);
				if (strpos($pub_key, '-----BEGIN PUBLIC KEY-----') === false)
					$pub_key = "-----BEGIN PUBLIC KEY-----\n" . $pub_key;

				if (strpos($pub_key, '-----END PUBLIC KEY-----') === false)
					$pub_key .= "\n-----END PUBLIC KEY-----";

				$key_resource = openssl_get_publickey($pub_key);

				openssl_public_encrypt($_POST["TRN"], $crypttext, $key_resource );
				$TRN = base64_encode($crypttext);

				// CRN
				openssl_public_encrypt($_POST["CRN"], $crypttext, $key_resource );
				$CRN = base64_encode($crypttext);

				// MID
				openssl_public_encrypt($merchant, $crypttext, $key_resource );
				$MID = base64_encode($crypttext);

				// Sign data
				$source = $merchant.$_POST["TRN"].$_POST["CRN"];
				
				$get = 'private.txt';
				$pat = dirname(__FILE__). '/';
				for($i = 0; $i < 10; $i++)
				{
					if(!file_exists($pat.$get))
					{
						$pat.="../";
					}
					else
					{
						break;
					}
				}
				$pat .= 'private.txt';
		


				$key = file_get_contents($pat);

				if (strpos($key, '-----BEGIN PRIVATE KEY-----') === false)
					$key = "-----BEGIN PRIVATE KEY-----\n" . $key;

				if (strpos($key, '-----END PRIVATE KEY-----') === false)
					$key .= "\n-----END PRIVATE KEY-----";
			
				$priv_key = openssl_pkey_get_private($key);
				$signature = '';
				openssl_sign($source, $signature, $priv_key, OPENSSL_ALGO_SHA1);
				$inputArray = array("SaleConf_req" => array("MID"    => $MID,
															"CRN"    => $CRN,
															"TRN"    => $TRN,
															"SIGNATURE" => base64_encode($signature)));
				$WSResult = $client->call("sendConfirmation", $inputArray);
				$error = $client->getError();
				$signature = base64_decode($WSResult["return"]["SIGNATURE"]);
				$data2      = $WSResult["return"]["RESCODE"].$WSResult["return"]["REPETETIVE"].$WSResult["return"]["AMOUNT"].$WSResult["return"]["DATE"].$WSResult["return"]["TIME"].$WSResult["return"]["TRN"].$WSResult["return"]["STAN"];

				$ok = openssl_verify($data2, $signature, $key_resource);
				if ($ok == 1) 
				{
					 if (($WSResult['return']['RESCODE'] == '00') && ($WSResult['return']['successful'] == true)) 
					 {
						 if(floatval($WSResult["return"]["AMOUNT"])  == floatval($amount))
						{
							$referenceId = $WSResult["return"]["TRN"];
							$data['authority'] = $referenceId;
							$data['continue'] = $this->url->link('checkout/success');
							$this->model_checkout_order->addOrderHistory($order_id, $this->config->get('payment_mabna_order_status_id'), 'کد ارجاع : '.$referenceId, true);
							$data['error_warning'] = NULL;
							$location = ($this->url->link('checkout/success', '', 'SSL'));
							
							if (!headers_sent()) {
								header('Location: ' . $location);
							  } else
							  {
								  echo '<script type="text/javascript">';
								  echo 'window.location.href="' . $location . '";';
								  echo '</script>';
							  }





						}
						else
						{
							$data['error_warning'] = $this->language->get('error_veryfi');
							$data['continue'] = $this->url->link('checkout/checkout');
						}
					}
					else 
					{
						$data['error_warning'] =$this->language->get('error_order_id');
						$data['continue'] = $this->url->link('checkout/checkout');
					}
				}
				else 
				{
					$data['error_warning'] =$this->language->get('error_order_id');
					$data['continue'] = $this->url->link('checkout/checkout');
				}
				
				}	
				else 
				{
					$data['error_warning'] =$this->language->get('error_order_id');
					$data['continue'] = $this->url->link('checkout/checkout');
				}			
		}
		else 
		{
			$data['error_warning'] = $this->language->get('error_order_2');
			$data['continue'] = $this->url->link('checkout/checkout');
		}
		
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['column_right'] = $this->load->controller('common/column_right');
		$data['content_top'] = $this->load->controller('common/content_top');
		$data['content_bottom'] = $this->load->controller('common/content_bottom');
		$data['footer'] = $this->load->controller('common/footer');
		$data['header'] = $this->load->controller('common/header');
		

		$this->response->setOutput($this->load->view('extension/payment/mabna_confirm', $data));
		
	

	}
}
?>